-- 
-- Animated Clock
-- Script by Blacky_BPG
-- for use with Clock by EasterEgg
-- last Change: 19.09.13
-- 

animatedClock = {};

local animatedClock_mt = Class(animatedClock);

function animatedClock.onCreate(id)
      g_currentMission:addUpdateable(animatedClock:new(id));
end;
  
function animatedClock:new(id)
	local self = {};
	setmetatable(self, animatedClock_mt);
  
	self.hourPointer = Utils.indexToObject(id, getUserAttribute(id, "hourPointer"));
	self.minutePointer = Utils.indexToObject(id, getUserAttribute(id, "minutePointer"));
	if self.hourPointer == nil or self.minutePointer == nil then
		print("ERROR: Animated Clock cant be created, one or more Pointers are not defined!");
		self.isEnabled = false;
		self.hourPointer = nil;
		self.minutePointer = nil;
		return;
	end;

	self.lastMinute = 0;

	self.isEnabled = true;
	
	return self;
end;

function animatedClock:delete()
end;

function animatedClock:update(dt)
	local cTime = (g_currentMission.environment.dayTime / 3600 / 1000);
	local hour = 0;
	local minute = 0;
	if cTime >= 12 then
		hour = math.floor(cTime) - 12;
	else
		hour = math.floor(cTime);
	end;
	minute = math.floor((cTime - hour) * 60);
	hour = hour + (minute / 60);
	local hourDegree = 360 / 12 * hour;
	local minuteDegree = 360 / 60 * minute;
	if self.lastMinute ~= minute then
		self.lastMinute = minute;
		setRotation(self.minutePointer, 0, Utils.degToRad(minuteDegree), 0);
		setRotation(self.hourPointer, 0, Utils.degToRad(hourDegree), 0);
	end;
end;

g_onCreateUtil.addOnCreateFunction("animatedClock", animatedClock.onCreate);
